function [bp1,irfb,wb]=bpaths1(mx,nlags,nvar,ct,h,n)

bp1=zeros(n*nvar^2,h+1);      %bootstrap replicates of response functions

y=zeros(nvar,ct);
mx1=mx;
for i=1:nvar
    mx1(1:ct,i)=mx(1:ct,i)-mean(mx(1:ct,i));
end

%estimate
bf=forb(mx, mx1, nlags, nvar, ct);

%calculate residuals
[T,T1]=size(mx);
yf=mx((nlags+1):T,1:T1);
xf=ones(T-nlags,1);

for i=1:nlags
    xf=[xf mx((nlags-i+1):(T-i),1:T1)];
end

uf=yf-xf*bf;
sigmaf=uf'*uf/(length(uf));
G0f=inv(xf'*xf)*(length(uf));
uf=uf*((ct-nlags)/(ct-nlags*nvar-1-nlags))^0.5; %scale residuals

%responses based on bias-corrected estimators
rb=ortirf(bf,nlags,nvar,h,sigmaf);

irfb=zeros(nvar^2,h+1);
for i=1:h+1
    for j=1:nvar
        irfb(nvar*(j-1)+1:nvar*j,i)=rb(nvar*i-nvar+1:nvar*i,j);
    end
end

d=randint(ct-nlags,n,[1,ct-nlags]);

%bootstrap replications
for l=1:n

    ee2=uf(d(:,l),:);

    %generate data
    y(:,1:nlags)=mx(1:nlags,:)';

    for i=nlags:ct-1
        xx=1;
        j=1;
        while(j<nlags+1)
            xx=[xx y(:,i-j+1)'];
            j=j+1;
        end
        y(:,i+1)=(xx*bf)'+ee2(i-nlags+1,:)';
    end

    yt=y';

    for i=1:nvar
        ym1(1:ct,i)=yt(1:ct,i)-mean(yt(1:ct,i));
    end

    nlags1=nlags;

    bf1=forb(yt, ym1, nlags1, nvar, ct);

    %calculate residuals
    [T,T1]=size(ym1);
    yf1=yt((nlags1+1):T,1:T1);
    xf1=ones(T-nlags1,1);

    for i=1:nlags1
        xf1=[xf1 yt((nlags1-i+1):(T-i),1:T1)];
    end

    uf1=yf1-xf1*bf1;
    sigmaf1=uf1'*uf1/(length(uf1));
    G0f1=inv(xf1'*xf1)*(length(uf1));

    Sigma=kron(sigmaf1,G0f1);
    w1=reshape(bf1-bf,nvar^2*nlags1+nvar,1);
    for b=1:nvar
        Sigma((b-1)*nvar*nlags1+1,:)=[];
        Sigma(:,(b-1)*nvar*nlags1+1)=[];
        w1((b-1)*nvar*nlags1+1)=[];
    end
    wb(l)=(T-nlags1)*w1'*inv(Sigma)*w1;  %Wald statistic

    rb1=ortirf(bf1,nlags1,nvar,h,sigmaf1);

    irfb1=zeros(nvar^2,h+1);
    for i=1:h+1
        for j=1:nvar
            irfb1(nvar*(j-1)+1:nvar*j,i)=rb1(nvar*i-nvar+1:nvar*i,j);
        end
    end

    for i=0:nvar^2-1
        bp1(i*n+l,:)=irfb1(i+1,:);
    end
end